<?php

// Function to retrieve the encryption key
function getEncryptionKey() {
    return "your_16_byte_key_";  // Example key (16 bytes)
}

// Function to perform decryption
function decryptData($data) {
    $key = getEncryptionKey();  // Retrieve the encryption key
    $iv = "1234567890123456";  // Static IV (16 bytes for AES-128-CBC)

    // Convert from hexadecimal to binary
    $decryptedData = hex2bin($data);
    if ($decryptedData === false) {
        throw new Exception('Invalid hexadecimal data.');
    }
    // Decrypt the data
    $decrypted = openssl_decrypt($decryptedData, "AES-128-CBC", $key, OPENSSL_RAW_DATA, $iv);
    if ($decrypted === false) {
        throw new Exception('Decryption failed.');
    }
    return $decrypted;  // Return the decrypted data
}

// Get the 'segment' and 'vtoken' parameters from the URL
$segment = isset($_GET['hex']) ? $_GET['hex'] : null;
$vtoken = isset($_GET['vai']) ? $_GET['vai'] : null;

if ($segment === null || $vtoken === null) {
    die("Missing segment or vtoken.");
}

// Decrypt the segment data
try {
    $decryptedData = decryptData($segment);
   // echo $decryptedData ;  // For debugging
} catch (Exception $e) {
    die("Decryption error: " . $e->getMessage());
}

$ch = curl_init();

// Set cURL options
curl_setopt($ch, CURLOPT_URL, $decryptedData);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // Return the response as a string
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // Follow redirects if any

// Optional: Set headers (if required for access)
$headers = [
    "Referer: ",
];
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

// Execute the cURL request
$response = curl_exec($ch);
echo $response;
?>
